program vjezba;

type niz = array[1..100] of Integer;
type niz_cifara = array[0..9] of Integer;

var 
    n, m, p, k: Integer;
    a, b, c: niz;

procedure unos_niza(var n: Integer; var a: niz);
var i: Integer;
begin
    ReadLn(n);
    for i := 1 to n do
    begin
        Read(a[i]);
    end;
end;

procedure stampa_niza(var n: Integer; var a: niz);
var i: Integer;
begin
    for i := 1 to n do
    begin
        Write(a[i], ' ');
    end;
    WriteLn();
end;

procedure zamjena(var a, b: Integer);
var tmp: Integer;
begin
    tmp := a;
    a := b;
    b := tmp;
end;

procedure okretanje(n: Integer; var a: niz);
var i: Integer;
begin
    for i := 1 to n div 2 do
    begin
        zamjena(a[i], a[n-i+1]);
    end;
end;

function duplikati(n: Integer; a: niz): Boolean;
var 
    i, j: Integer;
    ind: Boolean;
begin
    ind := False;
    for i := 1 to n-1 do
    begin
        for j := i+1 to n do
        begin
            if (a[i] = a[j]) then
            begin
                ind := True;
                Break;
            end;
        end;
        if (ind = True) then
        begin
            Break;
        end;
    end;
    duplikati := ind;
end;

procedure presjek(n, m: Integer; a, b: niz; var p: Integer; var c: niz);
var 
    i, j: Integer;
begin
    p := 0;
    for i := 1 to n do
    begin
        for j := 1 to m do
        begin
            if (a[i] = b[j]) then
            begin
                p := p + 1;
                c[p] := a[i];
                Break;
            end;
        end;
    end;
end;

// za vjezbu: eliminacija duplikata prije presjeka

function kvadriraj(n: Integer; a: niz): niz;
var 
    i: Integer;
    b: niz;
begin
    for i := 1 to n do
    begin
        b[i] := a[i]*a[i];
    end;
    kvadriraj := b;
end;

function ponovi_k(k, n: Integer; a: niz): niz;
var 
    i, j: Integer;
    b: niz;
begin
    for i := 1 to n do
    begin
        for j := 1 to k do
        begin
            b[(i-1)*k + j] := a[i];
        end;
    end;
    ponovi_k := b;
end;

function najcesci(n: Integer; a: niz): Integer;
var
    i, max_idx: Integer;
    b: niz;
begin
    for i := 1 to 100 do
    begin
        b[i] := 0;
    end;
    for i := 1 to n do
    begin
        b[a[i]] := b[a[i]] + 1;
    end;
    max_idx := 1;
    for i := 2 to 100 do
    begin
        if (b[max_idx] < b[i]) then
        begin
            max_idx := i;
        end;
    end;
    najcesci := max_idx;
end;

function br_razlicitih(n: Integer): Integer;
var 
    c, br: Integer;
    b: niz_cifara;
begin
    if (n = 0) then
    begin
        br_razlicitih := 1;
    end
    else 
    begin
        for c := 0 to 9 do
        begin
            b[c] := 0;
        end;
        while (n > 0) do
        begin
            c := n mod 10;
            n := n div 10;
            b[c] := 1;
        end;
        br := 0;
        for c := 0 to 9 do
        begin
            br := br + b[c];
        end;
        br_razlicitih := br;
    end;
end;

// za vjezbu: najcesca cifra, cifre koje se ne pojavljuju,
// eliminacija duplikata iz niza

procedure najduzi_rastuci_podniz(n: Integer; a: niz);
var i, j, maxd, pocetak, kraj, d: Integer;
begin
    maxd := 0;
    pocetak := 0; // moze i bez
    kraj := 0; // moze i bez
    i := 1;
    j := 1;
    while (i <= n) do
    begin
        while ((j+1 <= n) and (a[j] < a[j+1])) do
        begin
            j := j + 1;
        end;
        d := j - i + 1;
        if (maxd < d) then
        begin
            maxd := d;
            pocetak := i;
            kraj := j;
        end;
        i := j + 1;
        j := j + 1;
    end;
    WriteLn(maxd);
    for i := pocetak to kraj do
    begin
        write(a[i], ' ');
    end;
    WriteLn();
end;

begin
  
//unos_niza(n, a);
//unos_niza(m, b);

//okretanje(n, a);
//stampa_niza(n, a);

//WriteLn(duplikati(n, a));

//presjek(n, m, a, b, p, c);
//stampa_niza(p, c);

//unos_niza(n, a);

//b := kvadriraj(n, a);
//stampa_niza(n, b);

//ReadLn(k);
//b := ponovi_k(k, n, a);
//m := k*n;
//stampa_niza(m, b);

//unos_niza(n, a);
//WriteLn(najcesci(n, a));

//ReadLn(n);
//WriteLn(br_razlicitih(n));

unos_niza(n, a);
najduzi_rastuci_podniz(n, a);

end.